unit FirmaUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, DBCtrls, Mask;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Label1: TLabel;
    Table2: TTable;
    DataSource2: TDataSource;
    DBGrid2: TDBGrid;
    Label2: TLabel;
    Table2Naim: TStringField;
    Table2Model: TStringField;
    Table2Kolvo: TSmallintField;
    Table2Zena: TCurrencyField;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    DBLookupComboBox1: TDBLookupComboBox;
    InsertButton: TButton;
    EditButton: TButton;
    PostButton: TButton;
    CancelButton: TButton;
    DeleteButton: TButton;
    Table2Summa: TCurrencyField;
    Table2NSklad: TIntegerField;
    Label3: TLabel;
    DBText1: TDBText;
    procedure InsertButtonClick(Sender: TObject);
    procedure EditButtonClick(Sender: TObject);
    procedure PostButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure DeleteButtonClick(Sender: TObject);
    procedure DBEdit2KeyPress(Sender: TObject; var Key: Char);
    procedure Table2NaimChange(Sender: TField);
    procedure Table2ZenaValidate(Sender: TField);
    procedure Table2KolvoSetText(Sender: TField; const Text: String);
    procedure Table2KolvoGetText(Sender: TField; var Text: String;
      DisplayText: Boolean);
    procedure Table2CalcFields(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure EnabledVisual;
begin
    Form1.DBLookupComboBox1.Enabled:=True;
    Form1.DBEdit1.Enabled:=True;
    Form1.DBEdit2.Enabled:=True;
    Form1.DBEdit3.Enabled:=True;
end;
procedure DisabledVisual;
begin
    Form1.DBLookupComboBox1.Enabled:=False;
    Form1.DBEdit1.Enabled:=False;
    Form1.DBEdit2.Enabled:=False;
    Form1.DBEdit3.Enabled:=False;
end;

procedure TForm1.InsertButtonClick(Sender: TObject);
begin
  if Table2.State = dsBrowse then
  begin
    Table2.Insert;
    EnabledVisual;
  end;
end;

procedure TForm1.EditButtonClick(Sender: TObject);
begin
  if Table2.State = dsBrowse then
  begin
    Table2.Edit;
    EnabledVisual;
  end;
end;

procedure TForm1.PostButtonClick(Sender: TObject);
begin
  if (Table2.State = dsInsert) or
     (Table2.State = dsEdit) then
  begin
    Table2.Post;
    DisabledVisual;
  end;
end;

procedure TForm1.CancelButtonClick(Sender: TObject);
begin
  if Table2.State in [dsInsert,dsEdit] then
  begin
    Table2.Cancel;
    DisabledVisual;
  end;
end;

procedure TForm1.DeleteButtonClick(Sender: TObject);
begin
   if Table2.State = dsBrowse then
     if MessageDlg('    ?',mtConfirmation,[mbYes,mbNo],0) = mrYes then
       Table2.Delete;
end;

procedure TForm1.DBEdit2KeyPress(Sender: TObject; var Key: Char);
begin
  if not(key in ['0'..'9',#8]) then key:=chr(0);
end;

procedure TForm1.Table2NaimChange(Sender: TField);
begin
 ShowMessage ('  '+ DBLookupComboBox1.Field.AsString);
end;

procedure TForm1.Table2ZenaValidate(Sender: TField);
begin
  if Table2Zena.Value < 0 then
    begin
     ShowMessage('   ');
     Abort;
    end;
end;

procedure TForm1.Table2KolvoSetText(Sender: TField; const Text: String);
{  Text    }
begin
  if StrToInt64(Text) > 32767 then
    begin
     ShowMessage('  ');
     DBEdit2.SetFocus;
    end
  else
    Table2Kolvo.Value:=StrToInt(Text);
end;

procedure TForm1.Table2KolvoGetText(Sender: TField; var Text: String;
  DisplayText: Boolean);
begin
   if Table2.State = dsBrowse then
       Text:= Table2Kolvo.AsString + ' '
   else Text:=Table2Kolvo.AsString;
end;

procedure TForm1.Table2CalcFields(DataSet: TDataSet);
begin
   Table2Summa.Value:=Table2Kolvo.Value*Table2Zena.Value;
end;

end.
